<?php

if(!defined('_PS_VERSION_')){
	exit;
}
//include_once(dirname(__FILE__) . '/modules/library/gpndata.php');
include_once('C:\\inetpub\\wwwroot\\prestashop\\modules\\gpndata\\library\\gpndata.php');

class GpnDataPaymentModuleFrontController extends ModuleFrontController
{

	public function initContent(){

		try {

			if(empty(Tools::GetValue('action')) == false){
				//$action = Tools::GetValue('action');
				//$id_cart  = Tools::getValue('id_cart');
				
				//$this->validateOrderTransaction($id_cart, Tools::getValue('transactionid'), Tools::getValue('status'), Tools::getValue('key'));
			} 
			if(!$this->isTokenValid()){
				$this->ProcessPayment('Token is not valid. Unable to process payment');
			}

			parent::initContent();
			$cart = $this->context->cart;
			if(empty($cart->id)){
				$this->ProcessPayment('Cart data not valid.');
			}

			$response = $this->ProcessPayment($cart);
		}
		catch(Exception $ex){
			$this->redirectError($ex->getMessage());
		}
		if(isset($response->result)){
			if($response->result != 'SUCCESS'){
				$message = empty($response->errormessage) ? $response->description : $response->errormessage;
				$this->redirectError($message);
				$json['success'] = $response->customerurl;
			}
			else{
				Tools::redirect($response->customerurl);
			}
		}

		die();
	}

	private function redirectError($returnMessage){
		Tools::redirect(
				$this->context->link->getPageLink(
						'order',
						true,
						null,
						[
								'step'     => '3',
								'gpnerror' => $returnMessage
						]
				)
		);
		die();
	}

	private function ProcessPayment($cart){
		$result = '';
		try {
			$_API                 = new GPNDataAPI(
					Configuration::get('GPNDATA_API_USER'), Configuration::get('GPNDATA_API_PASSWORD'), Configuration::get('GPNDATA_API_KEY')
			);
			$_API->transactionUrl = Configuration::get('GPNDATA_API_URL');
			$_API->contactUrl     = Configuration::get('GPNDATA_CONTACT_URL');
			$_API->paymentPageUrl = Configuration::get('GPNDATA_PAYMENT_PAGE_URL');
			$totalAmount          = $cart->getOrderTotal();//getOrderTotal(true, Cart::BOTH);
			$customer             = new Customer(intval($cart->id_customer));
			$address              = new Address(intval($cart->id_address_invoice));
			$products             = $cart->getProducts(true);
			$currency             = new Currency((int)$this->context->cart->id_currency);
			$country_code         = $_API->mapIso(CountryCore::getIsoById($address->id_country));
			$merchanttransid      = $this->context->cart->id . '-' . time() . rand(100, 999);  // <-- required (see API doc)
			$key                  = sha1(sha1($merchanttransid) . '::' . Configuration::get('GPNDATA_API_KEY'));
			$status_ok            = sha1(sha1($merchanttransid) . '::' . Configuration::get('GPNDATA_API_KEY') . 'success');
			$status_failure       = sha1(sha1($merchanttransid) . '::' . Configuration::get('GPNDATA_API_KEY') . 'failure');
			//http://services.gpndata.hr/prestashop/index.php?fc=module&module=gpndata&controller=payment&action=test
			$successurl = Tools::getHttpHost(true).__PS_BASE_URI__.'modules/gpndata/validation.php?&id_cart='.(int)$this->context->cart->id.'&id_transaction='.$merchanttransid.'&status='.$status_ok.'&key='.$key;
			$failureurl = Tools::getHttpHost(true).__PS_BASE_URI__.'modules/gpndata/validation.php?&id_cart='.(int)$this->context->cart->id.'&id_transaction='.$merchanttransid.'&status='.$status_failure.'&key='.$key;;
			/*
			$successurl = Tools::getHttpHost(true) .
			              __PS_BASE_URI__ .
			              'index.php?fc=module&module=gpndata&controller=payment&action=success' .
			              '&transactionid=' .
			              $merchanttransid .
			              '&status=' .
			              $status_ok; .
			              '&key=' .
			              $key;
			$failureurl = Tools::getHttpHost(true) .
			              __PS_BASE_URI__ .
			              'index.php?fc=module&module=gpndata&controller=payment&action=failure' .
			              '&transactionid=' .
			              $merchanttransid .
			              '&status=' .
			              $status_failure .
			              '&key=' .
			              $key;*/
			$contacturl = Configuration::get('GPNDATA_CONTACT_URL');  // <-- for hyperlink in Payment Page

			$transactionDetails = $_API->constructTransactionDetails($merchanttransid, $totalAmount, $currency->iso_code, 'Payment PrestaShop ' . $merchanttransid);
			$_API->merchantName = Configuration::get('GPNDATA_PAYMENT_MERCHANT_NAME');
			$customerDetails    = $_API->constructCustomerDetails(
					$customer->firstname,
					$customer->lastname,
					$customer->email,
					$_API->getIpAddress(),
					$country_code,
					State::getNameById($address->id_state),
					$address->postcode,
					$address->city,
					$address->address1,
					$address->address2,
					$address->phone,
					(string)$customer->id
			);

			$productDetails = $_API->constructProductDetailsPaymentPage(
					$products,
					[
							'name'        => 'name',
							'description' => 'description_short',
							'price'       => 'price',
							'amount'      => 'cart_quantity'
					]
			);

			$result = $_API->StartCreditCardChargePaymentPage($transactionDetails, $customerDetails, $productDetails, $successurl, $failureurl, $contacturl);

		}
		catch(Exception $e){
			throw new Exception($e->getMessage(), 1);
		}

		return $result;
	}
}

?>